---
title: PaymentRequest.show()
slug: Web/API/PaymentRequest/show
tags:
  - API
  - Commerce
  - Experimental
  - Method
  - Payment Request
  - Payment Request API
  - PaymentRequest
  - Payments
  - Reference
  - Secure context
  - show
---
<div>{{securecontext_header}}{{APIRef("Payment Request API")}}</div>

<p><span class="seoSummary">The <strong>{{domxref('PaymentRequest')}}</strong> interface's <strong><code>show()</code></strong> method instructs the user agent to begin the process of showing and handling the user interface for the payment request to the user.</span></p>

<p>For security reasons, the <code>PaymentRequest.show()</code> method can't just be initiated at any time. It may only be called while handling events that represent user interactions, such as {{event("click")}}, {{event("keyup")}}, or the like.</p>

<p>Only one payment request can be in the process of being handled at once, across all documents. Once one <code>PaymentRequest</code>'s <code>show()</code> method has been called, any other call to <code>show()</code> will by rejected with an <code>AbortError</code> until the returned promise has been concluded, either by being fulfilled with a {{domxref("PaymentResponse")}} indicating the results of the payment request, or by being rejected with an error.</p>

<div class="notecard note">
<p><strong>Note:</strong> In reality, despite the fact that the specification says this can't be done, some browsers, including Firefox, support multiple active payment requests at a time.</p>
</div>

<p>If your architecture doesn't necessarily have all of the data ready to go at the moment it instantiates the payment interface by calling <code>show()</code>, specify the <code>detailsPromise</code> parameter, providing a {{jsxref("Promise")}} that is fulfilled once the data is ready. If this is provided, <code>show()</code> will not allow the user to interact with the payment interface until the promise is fulfilled, so that data can be updated prior to the user engaging with the payment process.</p>

<p>Processing the result and, if necessary, calling {{domxref("PaymentResponse.retry()")}} to retry a failed payment can all be done either asynchronously or synchronously, depending on your needs. For the best user experience, asynchronous solutions are typically the best way to go. Most examples on MDN and elsewhere use <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async</a></code>/<code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/await">await</a></code> to wait asynchronously while results are validated and so forth.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>paymentPromise</em> = <em>paymentRequest</em>.show(<em>detailsPromise</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>detailsPromise</code> {{optional_inline}}</dt>
 <dd>An optional {{jsxref("Promise")}} that you can provide if your architecture requires that the payment request's details need to be updated between instantiating the payment interface and the user beginning to interact with it. The promise should resolve with a {{domxref("PaymentDetailsUpdate")}} object containing the updated information.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that eventually resolves with a {{domxref("PaymentResponse")}}. The promise is resolved when the user accepts the payment request (such as by clicking a "Pay" button in the browser's payment sheet).</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>
 <p>The returned promise rejects with an <code>AbortError</code> if the {{Glossary("user agent")}} is already showing a payment panel. Only one payment panel may be visible at a time <em>across all documents loaded by the user agent</em>.</p>

 <p>The promise is also rejected with <code>AbortError</code> if the user cancels the payment request.</p>
 </dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The promise rejects with an <code>InvalidStateError</code> if the same payment has already been shown for this request (its state is <code>interactive</code> because it is being shown already).</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>The promise rejects with a <code>NotSupportedError</code> if the user agent does not support the payment methods specified when the {{domxref("PaymentRequest.PaymentRequest","PaymentRequest")}} constructor was called.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>The promise rejects with a <code>SecurityError</code> if the call to <code>show()</code> was not in response to a user action, such as a {{event("click")}} or {{event("keyup")}} event. Other reasons a <code>SecurityError</code> may be thrown are at the discretion of the user agent, and may include situations such as too many calls to <code>show()</code> being made in a short time or <code>show()</code> being called while payment requests are blocked by parental controls.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The most common patterns for using <code>show()</code> involve either the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async</a></code>/<code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/await">await</a></code> syntax or the use of <code>show().then().catch()</code> to handle the response and any possible rejection. Those look like this:</p>

<h3 id="asyncawait_syntax">async/await syntax</h3>

<p>Using <code>await</code> to wait for a promise to be resolved makes it possible to write the code to handle payments particularly cleanly:</p>

<pre class="brush: js">async function processPayment() {
  try {
    const payRequest = new PaymentRequest(methodData, details, options);

    payRequest.onshippingaddresschange = ev =&gt; ev.updateWith(checkAddress(payRequest));
    payRequest.onshippingoptionchange = ev =&gt; ev.updateWith(checkShipping(payRequest));

    const repsonse = await payRequest.show();
    await validateResponse(response);
  } catch(err) {
    /* handle the error; AbortError usually means a user cancellation */
  }
}
</pre>

<p>In this code, the methods <code>checkAddress()</code> and <code>checkShipping()</code>, respectively, check the shipping address and the shipping option changes and supply in response either a {{domxref("PaymentDetailsUpdate")}} object or a promise to return one; this object contains the fields in the {{domxref("PaymentResponse")}} which have been or need to be changed.</p>

<p>The <code>validateResponse()</code> method, below, is called once <code>show()</code> returns, in order to look at the returned <code>response</code> and either submit the payment or reject the payment as failed:</p>

<pre class="brush: js">async function validateResponse(response) {
  try {
    if (await checkAllValues(response)) {
      await response.complete("success");
    } else {
      await response.complete("fail");
    }
  } catch(err) {
    await response.complete("fail");
  }
}
</pre>

<p>Here, a custom function called <code>checkAllValues()</code> looks at each value in the <code>response</code> and ensures that they're valid, returning <code>true</code> if every field is valid or <code>false</code> if any are not. If and only if every field is valid, the {{domxref("PaymentResponse.complete", "complete()")}} method is called on the response with the string <code>"success"</code>, which indicates that everything is valid and that the payment can complete accordingly.</p>

<p>If any fields have unacceptable values, or if an exception is thrown by the previous code, <code>complete()</code> is called with the string <code>"fail"</code>, which indicates that the payment process is complete and failed.</p>

<p>Instead of immediately failing, you could choose to call {{domxref("PaymentResponse.retry", "retry()")}} on the response object to ask the user agent to try to process the payment again; this should usually only be done after the user has made any needed corrections to the order.</p>

<p>Starting the payment process, in the end, is as simple as calling the <code>processPayment()</code> method.</p>

<h3 id="thencatch_syntax">then/catch syntax</h3>

<p>You can also use the older promise-based approach to work with payments, using the {{jsxref("Promise.then", "then()")}} and {{jsxref("Promise.catch", "catch()")}} functions on the promise returned by <code>show()</code>:</p>

<pre class="brush: js">function processsPayment() {
  const payRequest = new PaymentRequest(methodData, details, options);

  payRequest.onshippingaddresschange = ev =&gt; ev.updateWith(checkAddress(payRequest));
  payRequest.onshippingoptionchange = ev =&gt; ev.updateWith(checkShipping(payRequest));

  payRequest.show()
    .then(response =&gt; validateResponse(response))
    .catch(err =&gt; handleError(err));
}
</pre>

<p>This is functionally equivalent to the <code>processPayment()</code> method using the <code>await</code> syntax.</p>

<pre class="brush: js">function validateResponse(response) {
  checkAllValues(response)
    .then(response =&gt; response.complete("success"))
    .catch(response =&gt; response.complete("fail"));
}
</pre>

<p>You could even have <code>checkAllValues()</code> be a synchronous function, although that may have performance implications you don't want to deal with:</p>

<pre class="brush: js">function validateResponse(response) {
  if (checkAllValues(response) {
    response.complete("success");
  } else {
    response.complete("fail");
  }
}
</pre>

<p>See the article <a href="/en-US/docs/Web/JavaScript/Guide/Using_promises">Using promises</a> for more information if you need more information about working with promises.</p>

<h2 id="Examples">Examples</h2>

<p>In the following example, a <code>PaymentRequest</code> object is instantiated before the <code>show()</code> method is called. This method triggers the user agent's built-in process for retrieving payment information from the user. The <code>show()</code> method returns a {{jsxref('Promise')}} that resolves to a {{domxref("PaymentResponse")}} object when the user interaction is complete. The developer then uses the information in the <code>PaymentResponse</code> object to format and send payment data to the server. You should send the payment information to the server asynchronously so that the final call to {{domxref("paymentResponse.complete()")}} can indicate the success or failure of the payment.</p>

<pre class="brush: js">button.onclick = async function handlePurchase() {
  // Initialization of PaymentRequest arguments are excerpted for the sake of
  // brevity.
  const payment = new PaymentRequest(methods, details, options);
  try {
    const response = await payment.show();
    // Process response here, including sending payment instrument
    // (e.g., credit card) information to the server.
    // paymentResponse.methodName contains the selected payment method
    // paymentResponse.details contains a payment method specific response
    await response.complete("success");
  } catch (err) {
    console.error("Uh oh, something bad happened", err.message);
  }
}
</pre>

<p>The following example shows how to update the payment sheet as it's being presented to the end-user.</p>

<pre class="brush: js">async function requestPayment() {
  // We start with AU$0 as the total.
  const initialDetails = {
    total: {
      label: "Total",
      amount: { value: "0", currency: "AUD" },
    },
  };
  const request = new PaymentRequest(methods, initialDetails, options);
  // Check if the user supports the `methods`
  if (!await request.canMakePayment()) {
    return; // no, so use a web form instead.
  }
  // Let's update the total as the sheet is shown
  const updatedDetails = {
    total: {
      label: "Total",
      amount: { value: "20", currency: "AUD" },
    },
  };
  const response = await request.show(updatedDetails);
  // Check response, etc...
}

document.getElementById("buyButton").onclick = requestPayment;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#show-method','show(optional detailsPromise)')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.show")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a></li>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API">Using the Payment Request API</a></li>
 <li>{{domxref('PaymentRequest.abort()')}}</li>
 <li>{{domxref("PaymentRequest.retry()")}}</li>
 <li>{{domxref("PaymentRequest.complete()")}}</li>
 <li>{{domxref("PaymentResponse")}}</li>
</ul>
